//----------------------------- -------------------------------

#include <owl\applicat.h>
#include <owl\decframe.h>
#include <owl\controlb.h>
#include <owl\buttonga.h>
#include <owl\statusba.h>
#include <owl\messageb.h>
#include <owl\opensave.h>
#include <owl\dc.h>
#include <string.h>
#include "decor.rc"

#define COL_ICONS 500 //    

TRect check;
TRect *rect[COL_ICONS];
TIcon *icons[COL_ICONS];
int col,Number;
char filename[50],iconname[50];
TMessageBar *msgbar1,*msgbar2;

//-------------------------------- ------------------------------

class TApp: public TApplication
{
  public:
	 TApp():TApplication(){}
	 void InitMainWindow();
};

//-----------------------------  ---------------------------

class TCWndw: public TWindow
{
  public:
	 TCWndw(TWindow *parent,const char far*title);
  protected:
	 void Paint(TDC&DC,BOOL,TRect&);
	 void EvLButtonDown(uint modKeys,TPoint &point);
	 void EvLButtonUp(uint modKeys,TPoint &point);
	 void CmFileSelect();
	 void CmIconSelect();
	 void CmIconReplace();
	 void CmAbout();
	 BOOL CanClose();
	 BOOL ReplaceIcon(int);
	 int NumIcon(int);

	 HINSTANCE hinstance;
	 HRSRC     hrsrc;
	 HGLOBAL   hglobal;
	 LPVOID    lpvoid;
	 HANDLE    handle;
	 HICON     hicon;
	 BOOL      result;

	 DECLARE_RESPONSE_TABLE(TCWndw);
};

//------------------------   ---------------------

DEFINE_RESPONSE_TABLE1(TCWndw,TWindow)
	EV_WM_LBUTTONDOWN,
	EV_WM_LBUTTONUP,
	EV_COMMAND(CM_FILESELECT, CmFileSelect),
	EV_COMMAND(CM_ICONSELECT, CmIconSelect),
	EV_COMMAND(CM_ICONREPLACE, CmIconReplace),
	EV_COMMAND(CM_ABOUT, CmAbout),
END_RESPONSE_TABLE;

//---------------------------  -----------------------

TCWndw::TCWndw(TWindow*parent,const char far*title):TWindow(parent,title) {}

//-------------------------------  ---------------------------

class TWndw : public TDecoratedFrame
{
  public:
	  TWndw(TWindow *parent, const char far *title, TWindow *client,
			  BOOL trackMenuSelection);
	 ~TWndw();
};

//---------------------------  -------------------------

TWndw::TWndw(TWindow *parent, const char far *title, TWindow *client,
BOOL trackMenuSelection):TDecoratedFrame(parent,title,client,trackMenuSelection)
{
  TButtonGadget *b;
  TSeparatorGadget *s;
  AssignMenu("MENU_1");
  TControlBar *cntrlBar = new TControlBar(this,TControlBar::Vertical);
  cntrlBar->SetHintMode(TGadgetWindow::EnterHints);
  b = new TButtonGadget(BMP_FILESELECT, CM_FILESELECT);
  cntrlBar->Insert(*b);
  b = new TButtonGadget(BMP_ICONSELECT, CM_ICONSELECT);
  cntrlBar->Insert(*b);
  b = new TButtonGadget(BMP_ICONREPLACE, CM_ICONREPLACE);
  cntrlBar->Insert(*b);
  s = new TSeparatorGadget(10);
  cntrlBar->Insert (*s);
  b = new TButtonGadget(BMP_ABOUT, CM_ABOUT);
  cntrlBar->Insert(*b);
  s = new TSeparatorGadget(10);
  cntrlBar->Insert (*s);
  b = new TButtonGadget(BMP_EXIT, CM_EXIT);
  cntrlBar->Insert(*b);
  Insert(*cntrlBar, TDecoratedFrame::Right);
  TStatusBar *statbar=new TStatusBar(this,TGadget::Embossed,TStatusBar::CapsLock|
												 TStatusBar::NumLock|TStatusBar::Overtype);
  statbar->SetText("    ");
  Insert(*statbar,TDecoratedFrame::Bottom);

  strcpy(filename,"  !");
  strcpy(iconname,"  !");

  msgbar2=new TMessageBar(this);
  msgbar2->SetText(iconname);
  Insert(*msgbar2,TDecoratedFrame::Bottom);

  msgbar1=new TMessageBar(this);
  msgbar1->SetText(filename);
  Insert(*msgbar1,TDecoratedFrame::Bottom);

  Attr.W = 820;
  Attr.H = 460;
  Attr.X = GetSystemMetrics(SM_CXSCREEN)/2-Attr.W/2;
  Attr.Y = GetSystemMetrics(SM_CYSCREEN)/2-Attr.H/2;

  col=0; Number=1;
  check.SetEmpty();
}

//-------------------------  ----------------------------

TWndw::~TWndw()
{
	for(int i=0;i<col;i++) delete icons[i];
}

//------------------------  --------------------------

void TCWndw::Paint(TDC &DC,BOOL,TRect&)
{
	int x=10,y=-32;
	//************************   
	for(int i=0;i<col;i++)
	{
	  if(!((i)%8)&&(i)) {x+=42; y=-32;}
	  y+=42;
	  DC.DrawIcon(x,y,*icons[i]);
	}
	//********* ,   
	if(check.left)
	{
	  TPen *pen = new TPen(13,3,PS_SOLID);
	  DC.SelectObject(*pen);
	  DC.MoveTo(check.left-3,check.top-3);
	  DC.LineTo(check.right+3,check.top-3);
	  DC.LineTo(check.right+3,check.bottom+3);
	  DC.LineTo(check.left-3,check.bottom+3);
	  DC.LineTo(check.left-3,check.top-3);
	  delete pen;
	}
}

//-----------------      ------------------

void TCWndw::EvLButtonDown(UINT,TPoint &point)
{
	 for(int i=0;i<col-1;i++)
	 if((point.x>=rect[i]->left)&&(point.x<=rect[i]->right)&&
		(point.y>=rect[i]->top)&&(point.y<=rect[i]->bottom)) Invalidate();
	 check.SetEmpty();
}

//-----------------      ---------------

void TCWndw::EvLButtonUp(UINT,TPoint &point)
{
	 //***********************  
	 for(int i=0;i<col-1;i++)
	 if((point.x>=rect[i]->left)&&(point.x<=rect[i]->right)&&
		(point.y>=rect[i]->top)&&(point.y<=rect[i]->bottom))
	 {
		 TDC *DC = new TClientDC(HWindow);
		 TPen *pen = new TPen(13,3,PS_SOLID);
		 DC->SelectObject(*pen);
		 DC->MoveTo(rect[i]->left-3,rect[i]->top-3);
		 DC->LineTo(rect[i]->right+3,rect[i]->top-3);
		 DC->LineTo(rect[i]->right+3,rect[i]->bottom+3);
		 DC->LineTo(rect[i]->left-3,rect[i]->bottom+3);
		 DC->LineTo(rect[i]->left-3,rect[i]->top-3);
		 delete pen;
		 delete DC;
		 Number=i+1;
		 check=*rect[i];
	 }
}

//---------------------------------- ---------------------------------

void TCWndw::CmFileSelect()
{
  //**********************    
  char errorMsg[81];
  TOpenSaveDialog::TData fileData(OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_PATHMUSTEXIST,
											 "(*.exe)|*.exe|",0,0,"*");
  TFileOpenDialog *dialog = new TFileOpenDialog(this, fileData,0," ");
  int result=dialog->Execute();
  if (result==IDOK)
  {
	  strcpy(filename,fileData.FileName);
	  strcat(strcpy(fileData.FileName,":  "),filename);
	  msgbar1->SetText(fileData.FileName);
  }
  else if (fileData.Error != 0)
  {
	  wsprintf(errorMsg,"  #%ld.", fileData.Error);
	  MessageBox(errorMsg, "",  MB_OK | MB_ICONEXCLAMATION);
  }
}

//----------------------------------- -------------------------------

void TCWndw::CmIconSelect()
{
  //**********************    
  col=0;
  check.SetEmpty();
  Invalidate();
  char errorMsg[81];
  TOpenSaveDialog::TData fileData(OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_PATHMUSTEXIST,
								 "(*.dll)|*.dll|  (*.exe)|*.exe|",0,0,"*");
  TFileOpenDialog *dialog = new TFileOpenDialog(this,fileData,0," ");
  int result=dialog->Execute();
  if (result==IDOK)
  {
	  strcpy(iconname,fileData.FileName);
	  strcat(strcpy(fileData.FileName,":  "),iconname);
	  msgbar2->SetText(fileData.FileName);
	  //**************************   
	  hinstance=LoadLibrary(iconname);
	  if(hinstance==NULL) MessageBox("   !","",
												MB_OK|MB_ICONEXCLAMATION);
	  col=0;
	  int x=10,y=-32;
	  TDC *DC=new TClientDC(HWindow);
	  do
	  {
		 if(!(col%8)&&(col)) {x+=42; y=-32;}
		 hicon=ExtractIcon(hinstance,iconname,col);
		 if(hicon==NULL && !col) MessageBox("   !","",
														 MB_OK|MB_ICONEXCLAMATION);
		 y+=42;
		 DC->DrawIcon(x,y,hicon);
		 icons[col]=new TIcon(hicon);
		 rect[col]=new TRect(x,y,x+32,y+32);
		 col++;
	  } while (hicon!=NULL);
	  delete DC;
	  FreeLibrary(hinstance);
  }
  else if (fileData.Error != 0)
  {
	  wsprintf(errorMsg,"  #%ld.", fileData.Error);
	  MessageBox(errorMsg, "",  MB_OK | MB_ICONEXCLAMATION);
  }
}

//------------------------   " "-------------------

void TCWndw::CmIconReplace()
{
	if(!strcmp(filename,"  !")) MessageBox(" !","",MB_OK|MB_ICONEXCLAMATION); else
	if(!strcmp(iconname,"  !")) MessageBox(" !","",MB_OK|MB_ICONEXCLAMATION); else
	if(!ReplaceIcon(Number)) MessageBox("   !","",MB_OK); else
	MessageBox(" !","",MB_OK);
}
//----------- (   )----------

BOOL TCWndw::ReplaceIcon(int Number)
{
  hinstance=LoadLibrary(iconname);
  if(hinstance == NULL) {MessageBox("   !","",MB_OK); return FALSE;}

  hrsrc = FindResource(hinstance,MAKEINTRESOURCE(NumIcon(Number)),MAKEINTRESOURCE(RT_ICON));
  if(hrsrc == NULL) {MessageBox("   !","",MB_OK); return FALSE;}

  hglobal = LoadResource(hinstance,hrsrc);
  if(hglobal == NULL) {MessageBox("   !","",MB_OK); return FALSE;}

  lpvoid = LockResource(hglobal);
  if(lpvoid == NULL) {MessageBox("   !","",MB_OK); return FALSE;}

  handle = BeginUpdateResource(filename,false);
  if(handle == NULL) {MessageBox("   ","",MB_OK); return FALSE;}

  result = UpdateResource(handle,MAKEINTRESOURCE(RT_ICON),MAKEINTRESOURCE(1),
  MAKELANGID(LANG_NEUTRAL,SUBLANG_NEUTRAL),lpvoid,SizeofResource(hinstance, hrsrc));
  if(result == FALSE) {MessageBox("   ","",MB_OK); return FALSE;}

  if(!EndUpdateResource(handle, FALSE)) return FALSE;
  if(!FreeLibrary(hinstance)) {MessageBox("FreeLibrary","",MB_OK); return FALSE;}
  return TRUE;
}

//---------------------------------- ---------------------------------
void TCWndw::CmAbout()
{
  MessageBox ("    .   !!! \nCopyright 2013", "",MB_OK);
}

/*----------------------   ---------------------

      ,     
    */

int TCWndw::NumIcon(int i)
{
  if(strstr(iconname,"moricons.dll"))
  {
	 switch(i)
	 {
		 case 67: case 68: case 69: case 49: case 26: case 27: case 28: case 29:
		 case 30: case 23: case 21: case 17: case 15: case 13: case 11: case 6:
		 case 96: case 97: case 98: case 99: case 100: case 101: case 102:
		 case 103: case 104: case 105: case 106: case 107: return 2*i-1;
		 case 108: return 220;
		 case 109: return 225;
		 case 110: return 228;
		 case 111: return 231;
		 case 112: return 234;
		 case 113: return 237;
		 case 114: return 246;
		 default: return 2*i;
	 }
  }
  else if(strstr(iconname,"progman.exe"))
  {
	 switch(i)
	 {
		 case 1: return 16;
		 case 2: return 12;
		 case 3: return 10;
		 case 4: return 4;
		 case 5: return 100;
		 case 7: return 26;
		 case 8: return 15;
		 case 9: return 2;
		 case 10: return 8;
		 case 11: return 22;
		 case 12: return 6;
		 case 49: return 103;
		 default: return 2*i+2;
	 }
  }
  else return i;
 }

//------------------------------------------------------------------------------

BOOL TCWndw::CanClose()
{
  int result=MessageBox("     ?","",
  MB_YESNO | MB_ICONQUESTION);
  if(result==IDYES) return TRUE; else return FALSE;
}

//------------------------------------------------------------------------------

void TApp::InitMainWindow()
{
  TWindow *client = new TCWndw (0,0);
  TDecoratedFrame *wndw= new TWndw(0,"  ",client,TRUE);
  MainWindow = wndw;
  MainWindow->SetIcon(this,ICON_1);
  SetMainWindow(wndw);
  EnableBWCC();
}

//------------------------------------------------------------------------------

int OwlMain(int,char *[])
{
  return TApp().Run();
}

//------------------------------------------------------------------------------















